<?php
/******************************************************************************
 @Author:     Roland Braband aka STam <stam@lanworld.de>
 @Homepage    http://www.der-dirigent.de
 about: general metafile access class for dediplugins
 how2use: set the dirname into the class name and constructor
 sample:
        dirname = /myplugin
        root_name = myplugin
        filename = 'myplugin_meta.php'
        classname = class myplugin_meta
        constructor = function myplugin_meta()
 change to Version 1.1:
        this class promote a multi client enviroment installation
******************************************************************************/
class multi_sample_meta {

	/*
	* public
	*/

	/*
	* vars
	*/

	// general plugin configuration!

	/*
	* enable functions for each client as a singel plugin
	* this feature supports sql-statements for each client
	*/
	var $multi_client = true;

	/*
	* enable auto load of plugin settings on DeDi startup
	* this feature supports dedi_values with group_named settings
	* sample:
	*        dirname = /myplugin
	*        group_name = myplugin
	*        $cfg_myplugin = array()
	*
	*/
	var $auto_settings = true;

	/*
	* simple set of the realname
	* sample:
	*        dirname = /myplugin
	*        root_name = myplugin
	*
	*/
	var $root_name = 'multi_sample';

	// standart vars for local use
	var $cfg_client = ''; // containing the client vars
	var $cfg_dedi   = ''; // containing the dedi vars
	var $is_unix    = ''; // containing the OS identifer
	var $dedi_db    = ''; // containing the db vars
	var $client     = ''; // containing the client identifer
	var $perm       = ''; // access 2 perm class
	var $lang       = ''; // containing the lang identifer
	var $rep        = ''; // access 2 repository class
	var $db			= ''; // access 2 db class

    /*
     * constructor
     */

	function multi_sample_meta($call_files = false)
	{
		global $rep, $cfg_dedi, $db, $dedi_db, $cfg_client, $perm;
		$this->db 	  	    = $db = new DB_dedi;;
		$this->rep 			= $rep;
		$this->perm         = $perm;
        $this->lang         = $this->perm->get_lang();
		$this->client       = $this->perm->get_client();
		$this->is_unix      = $this->check_os();
        $this->dedi_db 		= $dedi_db;
        $this->cfg_dedi 	= $cfg_dedi;
		$this->cfg_client 	= $cfg_client;
		$this->_files 		= array(
                              $this->_install   => $this->_install,
							  $this->_uninstall => $this->_uninstall,
							  $this->_update 	=> $this->_update,
							  $this->_config    => $this->_config,
                        	  $this->_settings  => $this->_settings,
							  $this->_module    => array(
							   					   $this->_install   => '3',
												   $this->_uninstall => '5',
												   $this->_update 	 => '6',
												   $this->_config    => '7'));
		if ( $call_files === true ) $this->_call_files();
	}

	/*
     * functions
     */

	// general execute
	function install($order = '')
	{
		return $this->_what($this->_install,   $order);
	}
	function uninstall($order = '')
	{
		return $this->_what($this->_uninstall, $order);
	}
	function update($order = '')
	{
		return $this->_what($this->_update,    $order);
	}
	function config($order = '')
	{
		return $this->_what($this->_config,    $order);
	}
	// client execute
	function client_install($order = '')
	{
		return $this->_what($this->_install . $this->_client,   $order);
	}
	function client_uninstall($order = '')
	{
		return $this->_what($this->_uninstall . $this->_client, $order);
	}
	function client_update($order = '')
	{
		return $this->_what($this->_update . $this->_client,    $order);
	}
    function client_config($order = '')
	{
		return $this->_what($this->_config . $this->_client,    $order);
	}

	// general init settings
	function init_settings()
	{
	    $order = $this->_settings;
		return $this->_init_settings($order);
	}

	// general get/set_vars
	function set($var, $val = '')
    {
        $this->$var = $val;
        return $this->get($var);
    }
    function get($var)
    {
        return $this->$var;
    }

	// general get file content
	function get_this($what, $order = '')
	{
		if ($order == '') $order = $this->_meta;
		return $this->_get($order, $what);
	}

	// general update file content
	function update_this($what, $string = '', $order = '')
	{
		if ($order == '') $order = $this->_meta;
		return $this->_update_file($order, $what, $string);
	}

	// some misc
	function version()
	{
		return $this->__version;
	}
	function multi_client()
	{
		return $this->multi_client;
	}
	function auto_settings()
	{
        return $this->auto_settings;
	}
	function check_os()
	{
        if (defined("PHP_OS") && strcmp(substr(PHP_OS,0,3),"WIN")) return false;
        elseif (strpos(getenv("OS"), "Win" ) >= 0) return false;
        return true;
    }

	/*
     * privat
     */

    /*
     * vars
     */

	var $__version 		= '1.2';        // version of this class
	var $__mode    		= array(  		// default mode set
	 				      'sql' => '1',
						  'php' => '2',
						  'xml' => '3',
						  'txt' => '4');
	var $_uninstall 	= 'uninstall';  // varname of 'uninstall' script
	var $_install 	    = 'install';    // varname of 'install' script
	var $_client 	    = '_client';    // varname of 'client' script
	var $_config    	= 'config'; 	// varname of 'config' script
	var $_update    	= 'update'; 	// varname of 'update' script
	var $_meta_ext      = 'meta';       // varname of the metafile extension
	var $_xml_ext       = 'dedimod';    // varname of the dedimodfile extension
	var $_settings      = 'database';   // functionality of plugin settings (database = read settings from dB|settings = read settings from file)
	var $_module        = 'module';     // functionality of module extraction
	var $_meta     		= 'meta';       // functionality of meta extraction
	var $_files     	= array();     	// containing the additinal file information
	var $_modul_dir  	= '/module';    // varname of '/module' directory
	var $_meta_dir    	= '/meta';      // varname of '/meta' directory
	var $_dir			= '';           // containing the name of local directory

    /*
     * functions
     */

	function _what($what, $order = '')
	{
		$return2 = true;
        if ($order == '') {
			$order = $this->_meta;
			$return2 = $this->_do($this->_module, $what);
		}
		if($return2) $return  = $this->_do($order, $what);
		return $return;
	}
	function _call_files($dir = '', $mode=0777)
	{
		if ( $dir == '' ) $dir = $this->_meta_dir;
        $this->_dir = dirname(__FILE__) . $dir;
		if ( !is_dir( $this->_dir ) ) {
        	if ($this->is_unix) {
                return ( $this->_call_files(dirname($this->_dir),$mode) and umask(000) and @mkdir( $this->_dir, $mode));
            } else {
                return ( $this->_call_files(dirname($this->_dir),$mode) and @mkdir( $this->_dir, $mode));
            }
		} else {
		    $_dh = opendir ( $this->_dir );
			while ( gettype ( $_file = readdir ( $_dh ) ) != 'boolean' ) {
				if ( is_readable ( $this->_dir."/$_file" ) ) {
					if ( ($_ext = substr ( strrchr( $_file, "." ), 1) ) == $this->_meta_ext) {
						$_name = str_replace ( '.'.$_ext,'', $_file );
						$this->_files["$_name"] = array('file' => $_file, 'mode' => false);
						$_mode = strpos ($this->_get($this->_meta, $_name), '<?php') !== false ? $this->__mode['php'] : $this->__mode['sql'];
						$this->_files["$_name"]['mode'] = $_mode;
					} elseif ( ($_ext = substr ( strrchr( $_file, "." ), 1) ) == $this->_xml_ext) {
                        $_name = str_replace ( '.'.$_ext,'', $_file );
                        $this->_files["$_name"] = array('file' => $_file, 'mode' => false);
                        $_mode = strpos ($this->_get($this->_module, $_name), '<?xml') !== false ? $this->__mode['xml'] : $this->__mode['txt'];
						$this->_files["$_name"]['mode'] = $_mode;
					}
				}
			}
		}
	}
	function _do($order, $what)
	{
        if ($order != $this->_module) {
			$_what 	 = $this->_files["$what"]['mode'];
			$_source = $this->_get($order, $what);
		} else {
			$_what   = $this->files["$order"]["$what"];
			$_source = $this->_get($order, 'all');
		}
		switch ( $_what ) {
			case 1:
			    return $this->rep->bulk_sql		($_source);
				break;
			case 2:
			    return $this->rep->run_php		($_source);
				break;
			case 3:
			    return $this->rep->install_xml	($_source);
				break;
			case 4:
			    return $this->rep->print_txt	($_source);
				break;
            case 5:
			    return $this->rep->uninstall_xml($_source);
				break;
            case 6:
			    return $this->rep->update_xml	($_source);
				break;
            case 7:
			    return true;
				break;
		}
	}
	function _get($order, $what = '')
	{
        if ($what == '') $what = $this->_meta;
        if ($order != $this->_module && $what != 'all') {
		    return($this->rep->_file($this->_dir.'/'.$this->_files["$what"]['file']));
		} else {
			foreach ($this->_xml as $_modul) {
				$_modul['content'] = $this->rep->_file($this->_dir.'/'.$_modul['file']);
				$_return[] = $_modul;
			}
			return $_return;
		}
	}
	function _update_file($order, $what, $string = '')
	{
		$_rebuild = false;
		$order_ext = '_'.$order.'ext';
		if ( is_array($this->_files["$what"]) ) {
			$_file = $this->_files["$what"]['file'];
		} else {
	 		$_file = $this->_files["$what"].'.'.$this->$order_ext;
	 		$_rebuild = true;
		}
		if ( $string == '' ) {
			$return = $this->rep->_delete($this->_dir."/$_file");
			$_rebuild = true;
		} else {
			$return = $this->rep->_write($this->_dir."/$_file", $string);
		}
		if ( $_rebuild === true ) $this->_call_files($this->$order);
  		return $return;
	}
	function _init_settings($order)
	{
	    switch ($order) {
            case 'database':
                return $this->rep->_init_settings($this->root_name);
                break;
            case 'settings':
                return $this->get_this($order);
                break;
        }
	}
}
?>
